


import 'package:equatable/equatable.dart';
import 'package:syncrow_app/utils/resource_manager/constants.dart';

abstract class CurtainEvent extends Equatable {
  const CurtainEvent();

  @override
  List<Object?> get props => [];
}

class OpenCurtain extends CurtainEvent {
  final DeviceType deviceType;

  const OpenCurtain(this.deviceType);

  @override
  List<Object?> get props => [deviceType];
}

class CloseCurtain extends CurtainEvent {
  final DeviceType deviceType;

  const CloseCurtain(this.deviceType);

  @override
  List<Object?> get props => [deviceType];
}

class InitCurtain extends CurtainEvent {}
class PauseCurtain extends CurtainEvent {}
class useCurtainEvent extends CurtainEvent {}
class InitialWizardEvent extends CurtainEvent {}
class UpdateCurtainEvent extends CurtainEvent {}


class ChangeFirstWizardSwitchStatusEvent extends CurtainEvent {
  final int value;
  final String deviceId;
  const ChangeFirstWizardSwitchStatusEvent(
      {required this.value, this.deviceId = ''});
  @override
  List<Object> get props => [value, deviceId];
}



class GroupAllOnEvent extends CurtainEvent {}

class GroupAllOffEvent extends CurtainEvent {}