import 'package:equatable/equatable.dart';

abstract class FlushSensorEvent extends Equatable {
  const FlushSensorEvent();

  @override
  List<Object> get props => [];
}

class FlushSensorLoadingEvent extends FlushSensorEvent {}

class FlushSensorInitialEvent extends FlushSensorEvent {}

class FlushSensorInitialDeviseInfo extends FlushSensorEvent {}

class FlushSensorUpdatedEvent extends FlushSensorEvent {}

class FlushSensorChangeIndicatorEvent extends FlushSensorEvent {
  final bool value;
  const FlushSensorChangeIndicatorEvent({required this.value});

  @override
  List<Object> get props => [value];
}

class FlushSensorChangeValueEvent extends FlushSensorEvent {
  final dynamic value;
  final String code;
  const FlushSensorChangeValueEvent({required this.value, required this.code});

  @override
  List<Object> get props => [value, code];
}

class FlushSensorGetDeviceReportsEvent extends FlushSensorEvent {
  final String deviceUuid;
  final String code;
  const FlushSensorGetDeviceReportsEvent({
    required this.deviceUuid,
    required this.code,
  });

  @override
  List<Object> get props => [deviceUuid, code];
}
