import 'package:equatable/equatable.dart';
import 'package:syncrow_app/features/devices/model/device_model.dart';

abstract class GatewayState extends Equatable {
  const GatewayState();

  @override
  List<Object> get props => [];
}

class GatewayInitialState extends GatewayState {}

class GatewayLoadingState extends GatewayState {}

class UpdateGatewayState extends GatewayState {
  final List<DeviceModel> list;
  const UpdateGatewayState({required this.list});

  @override
  List<Object> get props => [list];
}

class ErrorState extends GatewayState {
  final String message;
  const ErrorState({required this.message});

  @override
  List<Object> get props => [message];
}
