import 'package:equatable/equatable.dart';

abstract class WallSensorEvent extends Equatable {
  const WallSensorEvent();

  @override
  List<Object> get props => [];
}

class LoadingEvent extends WallSensorEvent {}

class InitialEvent extends WallSensorEvent {}

class WallSensorUpdatedEvent extends WallSensorEvent {}

class ChangeIndicatorEvent extends WallSensorEvent {
  final bool value;
  const ChangeIndicatorEvent({required this.value});

  @override
  List<Object> get props => [value];
}

class ChangeValueEvent extends WallSensorEvent {
  final int value;
  final String code;
  const ChangeValueEvent({required this.value, required this.code});

  @override
  List<Object> get props => [value, code];
}

class GetDeviceReportsEvent extends WallSensorEvent {
  final String deviceUuid;
  final String code;
  const GetDeviceReportsEvent({
    required this.deviceUuid,
    required this.code,
  });

  @override
  List<Object> get props => [deviceUuid, code];
}
