import 'package:equatable/equatable.dart';
import 'package:syncrow_app/features/devices/model/water_leak_model.dart';

 class WaterLeakState  extends Equatable {
  const WaterLeakState();

  @override
  List<Object> get props => [];
}

class WaterLeakInitialState extends WaterLeakState {}

class  WaterLeakLoadingState extends WaterLeakState {}

class WaterLeakFailedState extends WaterLeakState {
  final String errorMessage;

  const WaterLeakFailedState({required this.errorMessage});

  @override
  List<Object> get props => [errorMessage];
}

class UpdateState extends WaterLeakState {
  final WaterLeakModel waterSensor;
  const UpdateState({required this.waterSensor});

  @override
  List<Object> get props => [waterSensor];
}


class LoadingNewSate extends WaterLeakState {
  final WaterLeakModel waterSensor;
  const LoadingNewSate({required this.waterSensor});

  @override
  List<Object> get props => [waterSensor];
}
