import 'package:flutter/material.dart';
import 'package:syncrow_app/features/shared_widgets/default_scaffold.dart';

class CeilingHelpDescription extends StatelessWidget {
  const CeilingHelpDescription({super.key});

  @override
  Widget build(BuildContext context) {
    return DefaultScaffold(
      title: 'Help Description',
      child: Center(
        child: ListView(
          shrinkWrap: true,
          padding: const EdgeInsets.all(16.0),
          children: [
            Text(
              '1. Nobody, the report to someone\n'
              'Instruction: The propagation and processing of electromagnetic waves are complicated. '
              'There will be false alarms in the actual use of radar, and there will be some influencing '
              'factors in the environment, including:\n\n'
              'A. Physical disturbance: including air conditioning, fan, motor and other facilities vibration, '
              'cats, dogs, mice, birds and other animals passing by, which may cause radar misjudgement '
              'of the environment.\n\n'
              'B. Space electromagnetic wave disturbance: This includes the possible existence of high-power '
              'electrical equipment around the radar, electromagnetic-wave-intensive places, and the '
              'simultaneous coexistence of multiple radars and other environmental factors. These '
              'interferences are relatively few in home and office scenarios but may be more common '
              'in factories and industrial environments.\n\n'
              'C. Power supply disturbance: This is mainly caused by power supply radar crosstalk due to '
              'associated facilities and equipment in the mains environment, resulting in an unstable '
              'power supply for the radar and potential misjudgement.\n\n'
              '2. In the case of human misreporting no one:\n'
              'A. The presence of a human body may be beyond the radar test range.\n\n'
              'B. The human body is covered by metal or by extremely thick office desks and chairs.\n\n'
              'C. When sleeping, the body might not exhibit noticeable breathing micro-movements on the side, '
              'leading to a short-term misjudgement as nobody.',
              style: Theme.of(context).textTheme.bodyMedium,
            ),
          ],
        ),
      ),
    );
  }
}
