abstract class SecurityEvent {}

class SetPassword extends SecurityEvent {
  final String password;

  SetPassword(this.password);
}

class TogglePasswordVisibility extends SecurityEvent {}

class SubmitEvent extends SecurityEvent {}

class StartTimerEvent extends SecurityEvent {}

class StopTimerEvent extends SecurityEvent {}

class UpdateTimerEvent extends SecurityEvent {
  final int remainingTime;
  final bool isButtonEnabled;
  UpdateTimerEvent(
      {required this.remainingTime, required this.isButtonEnabled});
}

class ChangePasswordEvent extends SecurityEvent {
  final String otpCode;
  ChangePasswordEvent({
    required this.otpCode,
  });
}

class VerifyPassCodeEvent extends SecurityEvent {}
