import 'package:syncrow_app/features/scene/enum/operation_dialog_type.dart';
import 'package:syncrow_app/features/scene/model/scene_static_function.dart';
import 'package:syncrow_app/generated/assets.dart';

class OneGangHelperFunctions {
  static List<SceneStaticFunction> oneGangHelperFunctions(
      String deviceId, String deviceName, functionValue) {
    return [
      SceneStaticFunction(
        deviceType: '1G',
        deviceId: deviceId,
        deviceName: deviceName,
        icon: Assets.assetsAcPower,
        operationName: 'Light Switch',
        code: 'switch_1',
        functionValue: functionValue,
        operationDialogType: OperationDialogType.onOff,
        operationalValues: [
          SceneOperationalValue(
              icon: Assets.assetsAcPower, description: "ON", value: true),
          SceneOperationalValue(
              icon: Assets.assetsAcPowerOFF, description: "OFF", value: false),
        ],
      ),
      SceneStaticFunction(
        deviceType: '1G',
        deviceId: deviceId,
        deviceName: deviceName,
        icon: Assets.assetsLightCountdown,
        operationName: 'Light CountDown',
        code: 'countdown_1',
        functionValue: functionValue,
        operationDialogType: OperationDialogType.countdown,
        operationalValues: [
          SceneOperationalValue(icon: '', value: 0),
        ],
      ),
    ];
  }

  static List<SceneStaticFunction> oneGangAutomationFunctions(
      String deviceId, String deviceName, functionValue) {
    return [
      SceneStaticFunction(
        deviceType: '1G',
        deviceId: deviceId,
        deviceName: deviceName,
        icon: Assets.assetsAcPower,
        operationName: 'Light Switch',
        code: 'switch_1',
        functionValue: functionValue,
        operationDialogType: OperationDialogType.onOff,
        operationalValues: [
          SceneOperationalValue(
              icon: Assets.assetsAcPower, description: "ON", value: true),
          SceneOperationalValue(
              icon: Assets.assetsAcPowerOFF, description: "OFF", value: false),
        ],
      ),
      SceneStaticFunction(
        deviceType: '1G',
        deviceId: deviceId,
        deviceName: deviceName,
        icon: Assets.assetsLightCountdown,
        operationName: 'Light CountDown',
        code: 'countdown_1',
        functionValue: functionValue,
        operationDialogType: OperationDialogType.integerSteps,
        operationalValues: [
          SceneOperationalValue(
            icon: '',
            description: "sec",
            value: 0.0,
            minValue: 0,
            maxValue: 43200,
            stepValue: 1,
          ),
        ],
      ),
    ];
  }
}
